commit:     1b4ed94b1024801e10791b0bb89b9160de2b94c3
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Tue Oct 15 20:54:58 2024 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Tue Oct 15 20:54:58 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=1b4ed94b

app-shells/bash: add 5.3_alpha_p20241015

Signed-off-by: Sam James <sam <AT> gentoo.org>

 app-shells/bash/Manifest                        |   1 +
 app-shells/bash/bash-5.3_alpha_p20241015.ebuild | 411 ++++++++++++++++++++++++
 2 files changed, 412 insertions(+)

diff --git a/app-shells/bash/Manifest b/app-shells/bash/Manifest
index d4b75a6543bb..86445b9725d5 100644
--- a/app-shells/bash/Manifest
+++ b/app-shells/bash/Manifest
@@ -28,6 +28,7 @@ DIST 
bash-5.3_alpha_p20240927-254081c09767738833cdf161b4bc3feb1a51690a.tar.xz 85
 DIST bash-5.3_alpha_p20241008-9d1eb43fdd363137dd687bc411b14ab4946f939c.tar.gz 
14780002 BLAKE2B 
0aebf19e8d2b6074c9df71f6d6697fb1bfaae71d238ff4c38f52bc4f420f81bde311cb63cc5bec185da27799dd191939efe8355f3440e284ee84182b072c3277
 SHA512 
d9b928bc115877e3dd8f8d4f47757acd5c9ddd8f2e280d71ab03d1d3065b6a7e78e3989b181b10f09f3c9a03d2811bd26d54889c43ad8d8215fcf179c58644c3
 DIST bash-5.3_alpha_p20241011-c7439376a38960d518598178e30003931f74d0c1.tar.gz 
14809976 BLAKE2B 
a3091b048e1801c65ec428c958334a07c9643e8e698d3c70b46b0973b941c9e7cf69be49927cc0aa5be8c2075ee0fabde33ae18ce3f749302ff4ea93a018535b
 SHA512 
6d7e3c4cf3e78e9d7dcb46271f3db8d1c50d96713292796bb6770c6d86d35f1294c73873aa3709271d01fe96a0006b70629d23790e199fcc9ff2d7a7864f78d2
 DIST bash-5.3_alpha_p20241012-5edfaa45e791bbb2bf6c9342e13e5e364ff87bad.tar.gz 
15907066 BLAKE2B 
fd9806ddbcdf105c9722b83400b875d9c0aec88ac9c1aad22e386b9fcf7ba03bf1966e77a4bf4606c088b047ea5a0bfe5e291edf330e723bfe22db3e70fa7f24
 SHA512 
2706267da41702b9971b8f808498f8a683b387e653b34ac233067f4db7cb8f7b5e4bea3972a857338e14cdeea2e940f1541458b20a6732e93ffdea94d2c743d7
+DIST bash-5.3_alpha_p20241015-3ed028ccec871bc8d3b198c1681374b1e37df7cd.tar.gz 
15914321 BLAKE2B 
7ded011dbba5d9a017a03a7d8dca9bad3baaece4407c69f89f4aeb117bdac25e916e189bff38496ae127964ce5779a2dcf1de3d62b59d54f16a5c2811bfa09e3
 SHA512 
128d8f4bed5c69e6af8784607f4ef995d45a58a11ab9c47112d95459ef881e06f165406a337fd4ef12ab637883fd83a4c60b0a8a2a265ecd4ffead0786247fc4
 DIST bash205b-001 1132 BLAKE2B 
0c5eef29777d54ef05957ea3d63b1556fb380bd20c238dc28993d822b37bc4e78ff4048ad069f6b8cd25da77ccdeb7aecd86c4349cb9d81e5e94c7001eeae5e6
 SHA512 
5ce4357468821b05e747201f3aa57225ad8f540c9e2c87051720490e039c30b478b9b662a68f14a0800fefe40184e4495e2645665200f9d75e9a115b2ac08071
 DIST bash205b-002 755 BLAKE2B 
6a6ed5679d451f02f8104b345c1722d11718ce3b4043b581c17786d40d8da69a34786fb56d0c363dba277b8e9dd33f12f70c9cc73a9fc39ba4a8319406f0458d
 SHA512 
46947b0229478d5c2cfeff68b8ebc00e4ef0c8b94e336ca12f72b4490ba3622c0240c01c17c1641c3b07adc2c64ec94d6d780365e8990768ec8888f3a9526883
 DIST bash205b-003 2356 BLAKE2B 
b7887d00d92fd298cd07a15e1c73b516dabd22ecd74c97091636dd97a0cd55024ed698e5cc924c4311d994dd326b1ad074bea35e7650cf9cf4e25c60d2713fa7
 SHA512 
74528ca5d165b812d299f1c69b47757bd677c0b22ce4217e155cd641708b02364a93c6709fb57b546b376b36da74429a61493921c7c199563da40ddcf1c1f399

diff --git a/app-shells/bash/bash-5.3_alpha_p20241015.ebuild 
b/app-shells/bash/bash-5.3_alpha_p20241015.ebuild
new file mode 100644
index 000000000000..fa68a4aea9f4
--- /dev/null
+++ b/app-shells/bash/bash-5.3_alpha_p20241015.ebuild
@@ -0,0 +1,411 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+VERIFY_SIG_OPENPGP_KEY_PATH=/usr/share/openpgp-keys/chetramey.asc
+inherit flag-o-matic toolchain-funcs prefix verify-sig
+
+# Uncomment if we have a patchset.
+#GENTOO_PATCH_DEV="sam"
+#GENTOO_PATCH_VER="${PV}"
+
+MY_PV=${PV/_p*}
+MY_PV=${MY_PV/_/-}
+MY_P=${PN}-${MY_PV}
+MY_PATCHES=()
+
+# Determine the patchlevel.
+case ${PV} in
+       9999|*_alpha*|*_beta*|*_rc*)
+               # Set a negative patchlevel to indicate that it's a pre-release.
+               PLEVEL=-1
+               ;;
+       *_p*)
+               PLEVEL=${PV##*_p}
+               ;;
+       *)
+               PLEVEL=0
+esac
+
+# The version of readline this bash normally ships with. Note that we only use
+# the bundled copy of readline for pre-releases.
+READLINE_VER="8.3_alpha"
+
+DESCRIPTION="The standard GNU Bourne again shell"
+HOMEPAGE="https://tiswww.case.edu/php/chet/bash/bashtop.html 
https://git.savannah.gnu.org/cgit/bash.git";
+
+if [[ ${PV} == 9999 ]]; then
+       EGIT_REPO_URI="https://git.savannah.gnu.org/git/bash.git";
+       EGIT_BRANCH=devel
+       inherit git-r3
+elif (( PLEVEL < 0 )) && [[ ${PV} == *_p* ]] ; then
+       # It can be useful to have snapshots in the pre-release period once
+       # the first alpha is out, as various bugs get reported and fixed from
+       # the alpha, and the next pre-release is usually quite far away.
+       #
+       # i.e. if it's worth packaging the alpha, it's worth packaging a 
followup.
+       BASH_COMMIT="3ed028ccec871bc8d3b198c1681374b1e37df7cd"
+       
SRC_URI="https://git.savannah.gnu.org/cgit/bash.git/snapshot/bash-${BASH_COMMIT}.tar.gz
 -> ${P}-${BASH_COMMIT}.tar.gz"
+       S=${WORKDIR}/${PN}-${BASH_COMMIT}
+else
+       my_urls=( 
{'mirror://gnu/bash','ftp://ftp.cwru.edu/pub/bash'}/"${MY_P}.tar.gz" )
+
+       # bash-5.1 -> bash51
+       my_p=${PN}$(ver_cut 1-2) my_p=${my_p/.}
+
+       for (( my_patch_idx = 1; my_patch_idx <= PLEVEL; my_patch_idx++ )); do
+               printf -v my_patch_ver %s-%03d "${my_p}" "${my_patch_idx}"
+               my_urls+=( 
{'mirror://gnu/bash','ftp://ftp.cwru.edu/pub/bash'}/"${MY_P}-patches/${my_patch_ver}"
 )
+               MY_PATCHES+=( "${DISTDIR}/${my_patch_ver}" )
+       done
+
+       SRC_URI="${my_urls[*]} verify-sig? ( ${my_urls[*]/%/.sig} )"
+       S=${WORKDIR}/${MY_P}
+
+       unset -v my_urls my_p my_patch_idx my_patch_ver
+fi
+
+if [[ ${GENTOO_PATCH_VER} ]]; then
+       SRC_URI+=" 
https://dev.gentoo.org/~${GENTOO_PATCH_DEV:?}/distfiles/${CATEGORY}/${PN}/${PN}-${GENTOO_PATCH_VER:?}-patches.tar.xz";
+fi
+
+LICENSE="GPL-3+"
+SLOT="0"
+if (( PLEVEL >= 0 )); then
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips ~ppc 
~ppc64 ~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~arm64-macos ~ppc-macos 
~x64-macos ~x64-solaris"
+fi
+IUSE="afs bashlogger examples mem-scramble +net nls plugins pgo +readline"
+
+DEPEND="
+       >=sys-libs/ncurses-5.2-r2:=
+       nls? ( virtual/libintl )
+"
+if (( PLEVEL >= 0 )); then
+       DEPEND+=" readline? ( >=sys-libs/readline-${READLINE_VER}:= )"
+fi
+RDEPEND="
+       ${DEPEND}
+"
+# We only need bison (yacc) when the .y files get patched (bash42-005, 
bash51-011).
+BDEPEND="
+       pgo? ( dev-util/gperf )
+       verify-sig? ( sec-keys/openpgp-keys-chetramey )
+"
+
+# EAPI 8 tries to append it but it doesn't exist here.
+QA_CONFIGURE_OPTIONS="--disable-static"
+
+PATCHES=(
+       #"${WORKDIR}"/${PN}-${GENTOO_PATCH_VER}/
+
+       # Patches to or from Chet, posted to the bug-bash mailing list.
+       "${FILESDIR}/${PN}-5.0-syslog-history-extern.patch"
+)
+
+pkg_setup() {
+       # bug #7332
+       if is-flag -malign-double; then
+               eerror "Detected bad CFLAGS '-malign-double'.  Do not use this"
+               eerror "as it breaks LFS (struct stat64) on x86."
+               die "remove -malign-double from your CFLAGS mr ricer"
+       fi
+
+       if use bashlogger; then
+               ewarn "The logging patch should ONLY be used in restricted 
(i.e. honeypot) envs."
+               ewarn "This will log ALL output you enter into the shell, you 
have been warned."
+       fi
+}
+
+src_unpack() {
+       local patch
+
+       if [[ ${PV} == 9999 ]]; then
+               git-r3_src_unpack
+       elif (( PLEVEL < 0 )) && [[ ${PV} == *_p* ]] ; then
+               default
+       else
+               if use verify-sig; then
+                       verify-sig_verify_detached 
"${DISTDIR}/${MY_P}.tar.gz"{,.sig}
+
+                       for patch in "${MY_PATCHES[@]}"; do
+                               verify-sig_verify_detached "${patch}"{,.sig}
+                       done
+               fi
+
+               unpack "${MY_P}.tar.gz"
+
+               if [[ ${GENTOO_PATCH_VER} ]]; then
+                       unpack "${PN}-${GENTOO_PATCH_VER}-patches.tar.xz"
+               fi
+       fi
+}
+
+src_prepare() {
+       # Include official patches.
+       (( PLEVEL > 0 )) && eapply -p0 "${MY_PATCHES[@]}"
+
+       # Clean out local libs so we know we use system ones w/releases. The
+       # touch utility is invoked for the benefit of config.status.
+       if (( PLEVEL >= 0 )); then
+               rm -rf lib/{readline,termcap}/* \
+               && touch lib/{readline,termcap}/Makefile.in \
+               && sed -i -E 
's:\$[{(](RL|HIST)_LIBSRC[)}]/[[:alpha:]_-]*\.h::g' Makefile.in \
+               || die
+       fi
+
+       # Prefixify hardcoded path names. No-op for non-prefix.
+       hprefixify pathnames.h.in
+
+       # Avoid regenerating docs after patches, bug #407985.
+       sed -i -E '/^(HS|RL)USER/s:=.*:=:' doc/Makefile.in \
+       && touch -r . doc/* \
+       || die
+
+       # Sometimes hangs (more noticeable w/ pgo), bug #907403.
+       rm tests/run-jobs || die
+
+       eapply -p0 "${PATCHES[@]}"
+       eapply_user
+}
+
+src_configure() {
+       local -a myconf
+
+       # Upstream only test with Bison and require GNUisms like YYEOF and
+       # YYERRCODE. The former at least may be in POSIX soon:
+       # https://www.austingroupbugs.net/view.php?id=1269.
+       # configure warns on use of non-Bison but doesn't abort. The result
+       # may misbehave at runtime.
+       unset -v YACC
+
+       # wcsnwidth(), substring() issues with -Wlto-type-mismatch, reported
+       # upstream to Chet by email.
+       filter-lto
+
+       myconf=(
+               --disable-profiling
+
+               # Force linking with system curses ... the bundled termcap lib
+               # sucks bad compared to ncurses.  For the most part, ncurses
+               # is here because readline needs it.  But bash itself calls
+               # ncurses in one or two small places :(.
+               --with-curses
+
+               $(use_enable mem-scramble)
+               $(use_enable net net-redirections)
+               $(use_enable readline)
+               $(use_enable readline bang-history)
+               $(use_enable readline history)
+               $(use_with afs)
+               $(use_with mem-scramble bash-malloc)
+       )
+
+       # For descriptions of these, see config-top.h.
+       # bashrc/#26952 bash_logout/#90488 ssh/#24762 mktemp/#574426
+       append-cppflags \
+               
-DDEFAULT_PATH_VALUE=\'\""${EPREFIX}"/usr/local/sbin:"${EPREFIX}"/usr/local/bin:"${EPREFIX}"/usr/sbin:"${EPREFIX}"/usr/bin:"${EPREFIX}"/sbin:"${EPREFIX}"/bin\"\'
 \
+               
-DSTANDARD_UTILS_PATH=\'\""${EPREFIX}"/bin:"${EPREFIX}"/usr/bin:"${EPREFIX}"/sbin:"${EPREFIX}"/usr/sbin\"\'
 \
+               -DSYS_BASHRC=\'\""${EPREFIX}"/etc/bash/bashrc\"\' \
+               -DSYS_BASH_LOGOUT=\'\""${EPREFIX}"/etc/bash/bash_logout\"\' \
+               -DNON_INTERACTIVE_LOGIN_SHELLS \
+               -DSSH_SOURCE_BASHRC \
+               $(use bashlogger && echo -DSYSLOG_HISTORY)
+
+       use nls || myconf+=( --disable-nls )
+
+       if (( PLEVEL >= 0 )); then
+               # Historically, we always used the builtin readline, but since
+               # our handling of SONAME upgrades has gotten much more stable
+               # in the PM (and the readline ebuild itself preserves the old
+               # libs during upgrades), linking against the system copy should
+               # be safe.
+               # Exact cached version here doesn't really matter as long as it
+               # is at least what's in the DEPEND up above.
+               export ac_cv_rl_version=${READLINE_VER%%_*}
+
+               # Use system readline only with released versions.
+               myconf+=( --with-installed-readline=. )
+       fi
+
+       if use plugins; then
+               append-ldflags "-Wl,-rpath,${EPREFIX}/usr/$(get_libdir)/bash"
+       else
+               # Disable the plugins logic by hand since bash doesn't provide
+               # a way of doing it.
+               export ac_cv_func_dl{close,open,sym}=no \
+                       ac_cv_lib_dl_dlopen=no ac_cv_header_dlfcn_h=no
+
+               sed -i -e '/LOCAL_LDFLAGS=/s:-rdynamic::' configure || die
+       fi
+
+       # bug #444070
+       tc-export AR
+
+       econf "${myconf[@]}"
+}
+
+src_compile() {
+       local -a pgo_generate_flags pgo_use_flags
+       local flag
+
+       # -fprofile-partial-training because upstream notes the test suite isn't
+       # super comprehensive.
+       # 
https://documentation.suse.com/sbp/all/html/SBP-GCC-10/index.html#sec-gcc10-pgo
+       if use pgo; then
+               pgo_generate_flags=(
+                       -fprofile-update=atomic
+                       -fprofile-dir="${T}"/pgo
+                       -fprofile-generate="${T}"/pgo
+               )
+               pgo_use_flags=(
+                       -fprofile-use="${T}"/pgo
+                       -fprofile-dir="${T}"/pgo
+               )
+               if flag=$(test-flags-CC -fprofile-partial-training); then
+                       pgo_generate_flags+=( "${flag}" )
+                       pgo_use_flags+=( "${flag}" )
+               fi
+       fi
+
+       emake CFLAGS="${CFLAGS} ${pgo_generate_flags[*]}"
+       use plugins && emake -C examples/loadables CFLAGS="${CFLAGS} 
${pgo_generate_flags[*]}" all others
+
+       # Build Bash and run its tests to generate profiles.
+       if (( ${#pgo_generate_flags[@]} )); then
+               # Used in test suite.
+               unset -v A
+
+               emake CFLAGS="${CFLAGS} ${pgo_generate_flags[*]}" -k check
+
+               if tc-is-clang; then
+                       llvm-profdata merge "${T}"/pgo 
--output="${T}"/pgo/default.profdata || die
+               fi
+
+               # Rebuild Bash using the profiling data we just generated.
+               emake clean
+               emake CFLAGS="${CFLAGS} ${pgo_use_flags[*]}"
+               use plugins && emake -C examples/loadables CFLAGS="${CFLAGS} 
${pgo_use_flags[*]}" all others
+       fi
+}
+
+src_test() {
+       # Used in test suite.
+       unset -v A
+
+       default
+}
+
+src_install() {
+       local d f
+
+       default
+
+       my_prefixify() {
+               while read -r; do
+                       if [[ $REPLY == *$1* ]]; then
+                               REPLY=${REPLY/"/etc/"/"${EPREFIX}/etc/"}
+                       fi
+                       printf '%s\n' "${REPLY}" || ! break
+               done < "$2" || die
+       }
+
+       dodir /bin
+       mv -- "${ED}"/usr/bin/bash "${ED}"/bin/ || die
+       dosym bash /bin/rbash
+
+       insinto /etc/bash
+       doins "${FILESDIR}"/bash_logout
+       my_prefixify bashrc.d "${FILESDIR}"/bashrc-r1 | newins - bashrc
+
+       insinto /etc/bash/bashrc.d
+       my_prefixify DIR_COLORS "${FILESDIR}"/bashrc.d/10-gentoo-color.bash | 
newins - 10-gentoo-color.bash
+       newins "${FILESDIR}"/bashrc.d/10-gentoo-title-r1.bash 
10-gentoo-title.bash
+       if [[ ! ${EPREFIX} ]]; then
+               doins "${FILESDIR}"/bashrc.d/15-gentoo-bashrc-check.bash
+       fi
+
+       insinto /etc/skel
+       for f in bash{_logout,_profile,rc}; do
+               newins "${FILESDIR}/dot-${f}" ".${f}"
+       done
+
+       if use plugins; then
+               exeinto "/usr/$(get_libdir)/bash"
+               set -- examples/loadables/*.o
+               doexe "${@%.o}"
+
+               insinto /usr/include/bash-plugins
+               doins *.h builtins/*.h include/*.h 
lib/{glob/glob.h,tilde/tilde.h}
+       fi
+
+       if use examples; then
+               for d in examples/{functions,misc,scripts,startup-files}; do
+                       exeinto "/usr/share/doc/${PF}/${d}"
+                       docinto "${d}"
+                       for f in "${d}"/*; do
+                               if [[ ${f##*/} != @(PERMISSION|*README) ]]; then
+                                       doexe "${f}"
+                               else
+                                       dodoc "${f}"
+                               fi
+                       done
+               done
+       fi
+
+       # Install bash_builtins.1 and rbash.1.
+       emake -C doc DESTDIR="${D}" install_builtins
+       sed 's:bash\.1:man1/&:' doc/rbash.1 > "${T}"/rbash.1 || die
+       doman "${T}"/rbash.1
+
+       newdoc CWRU/changelog ChangeLog
+       dosym bash.info /usr/share/info/bashref.info
+}
+
+pkg_preinst() {
+       if [[ -e ${EROOT}/etc/bashrc ]] && [[ ! -d ${EROOT}/etc/bash ]]; then
+               mkdir -p -- "${EROOT}"/etc/bash \
+               && mv -f -- "${EROOT}"/etc/bashrc "${EROOT}"/etc/bash/ \
+               || die
+       fi
+}
+
+pkg_postinst() {
+       local old_ver
+
+       # If /bin/sh does not exist, provide it.
+       if [[ ! -e ${EROOT}/bin/sh ]]; then
+               ln -sf -- bash "${EROOT}"/bin/sh || die
+       fi
+
+       read -r old_ver <<<"${REPLACING_VERSIONS}"
+       if [[ ! $old_ver ]]; then
+               :
+       elif ver_test "$old_ver" -ge "5.2" && ver_test "$old_ver" -ge 
"5.2_p26-r8"; then
+               return
+       fi
+
+       while read -r; do ewarn "${REPLY}"; done <<'EOF'
+Files under /etc/bash/bashrc.d must now have a suffix of .sh or .bash.
+
+Gentoo now defaults to defining PROMPT_COMMAND as an array. Depending on the
+characteristics of the operating environment, it may contain a command to set
+the terminal's window title. Those who were already choosing to customise the
+PROMPT_COMMAND variable are now advised to append their commands like so:
+
+PROMPT_COMMAND+=('custom command goes here')
+
+Gentoo no longer defaults to having bash set the window title in the case
+that the terminal is controlled by sshd(8), unless screen is launched on the
+remote side or the terminal reliably supports saving and restoring the title
+(as alacritty, foot and tmux do). Those wanting for the title to be set
+regardless may adjust ~/.bashrc - or create a custom /etc/bash/bashrc.d
+drop-in - to set PROMPT_COMMMAND like so:
+
+PROMPT_COMMAND=(genfun_set_win_title)
+
+Those who would prefer for bash never to interfere with the window title may
+now opt out of the default title setting behaviour, either with the "unset -v
+PROMPT_COMMAND" command or by re-defining PROMPT_COMMAND as desired.
+EOF
+}

Reply via email to